<?php
/**
 * FAQ widget
 */
class random_FAQ_Widget extends WP_Widget {
	function random_FAQ_Widget() {
		$widget_ops = array( 'classname' => 'faq_widget', 'description' => 'Lists a random FAQ on the sidebar' );
		$this->WP_Widget( 'faq', 'FAQ Widget', $widget_ops );
	}

	function widget( $args, $instance ) {
		extract( $args, EXTR_SKIP );
		echo $before_widget;
		$title = empty($instance['title']) ? 'Frequently Asked Question' : apply_filters('widget_title', $instance['title']);
		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
		global $post;
			$args = array(
				'post_type' => 'question',
				'numberposts' => 1,
				'orderby' => 'rand',
				);
		$faqs = get_posts( $args );
		foreach( $faqs as $post ) :	setup_postdata($post);
		echo '<h4 class="faq_widget_title">'.get_the_title().'</h4>';
		echo '<p>'.faq_widget_excerpt(10).'</p>';
		echo '<p><a href="'.get_permalink().'">See the entire answer</a></p>';
        endforeach;
		wp_reset_query();
		echo $after_widget;
		?>
        
        <?php }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
	$instance = $old_instance;
	$instance['title'] = strip_tags($new_instance['title']);
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $instance = wp_parse_args( (array) $instance, array( 'title' => '') );
		$title = strip_tags($instance['title']);
        ?>
        <p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Widget Title:' ); ?><input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo isset( $instance['title'] ) ? $instance['title'] : ''; ?>" /></label></p>
        <?php }

} // class 

// register widget

add_action( 'widgets_init', create_function( '', "register_widget('random_FAQ_Widget');" ) );
